/* Copyright Ledbetter & Harp LLC  All rights reserved. */
/* rtb_0601.p -- Xref Report - External Objects */

{rtb/g/rtbglobl.i NEW}
{rtb/g/rtbrptv.i} /* print destination variables */
{rtb/g/rtb_prpr.i} /* needed for XREF-TYPE-LIST */

DEFINE TEMP-TABLE ttXref LIKE rtb.rtb_xref.

DEFINE VARIABLE Mref-type AS CHARACTER FORMAT "x(12)" NO-UNDO.

{rtb_inst/v7begin.i}
IF SESSION:DISPLAY-TYPE <> "TTY"
AND NOT SESSION:V6DISPLAY
THEN DO:
    /* --- no action --- */
END.
ELSE
{rtb_inst/v7end.i}  */ 
  DO:
  DISPLAY
    ""
  WITH FRAME rpt-name-frame
    ROW 5
    COLUMN 20 
    TITLE " External Objects Report - rtb_0601.p ".
END.  /* if session:display-type <> tty */

/* set print destination */
{rtb/g/rtbrpt1.i} 

FIND rtb.rtb_wspace
     WHERE rtb.rtb_wspace.wspace-id = Grtb-wspace-id
       NO-LOCK.

 /*
  Build a temp-table of all RUN references to informal objects.. 
 */
 FOR EACH rtb.rtb_object WHERE
          rtb.rtb_object.wspace-id = Grtb-wspace-id AND
          rtb.rtb_object.obj-type  = "PCODE":U NO-LOCK,
     EACH rtb.rtb_xref WHERE
          rtb.rtb_xref.src-recid = RECID(rtb.rtb_object) AND
          rtb.rtb_xref.ref-type = {&XREF_PROG} AND
          rtb.rtb_xref.ref-recid1 = 0 NO-LOCK:

  CREATE ttXref.
  BUFFER-COPY rtb.rtb_xref to ttXref.

END.  /* each rtb.rtb_object */

/*
 Since internal procedure show up as {XREF_PROG}, find all references to
 internal procedure in the given workspace and remove them from our list.
*/
FOR EACH rtb.rtb_xref
   WHERE rtb.rtb_xref.wspace-recid = RECID(rtb.rtb_wspace)
     AND rtb.rtb_xref.ref-type     = {&XREF_INTPROC}
   BREAK BY rtb.rtb_xref.obj-text:

  IF FIRST-OF(rtb.rtb_xref.obj-text) THEN DO:

    FOR EACH ttXref
        WHERE ttXref.wspace-recid = RECID(rtb.rtb_wspace)
          AND ttXref.ref-type     = {&XREF_PROG}
          AND ttXref.obj-text     = rtb.rtb_xref.obj-text:
       DELETE ttXref.
    END.

  END. /* first-of */
END. /* each rtb.rtb_xref */

/*
 Print the report based on the contents of our temp-table.. 
*/
FOR EACH ttXref
  BY ttXref.obj-text
  WITH FRAME ext-prog-obj-frame:

  {rtb/x/rtb_rpthdr.i
    &title="""External Objects Report"""
    &criteria="""Workspace:"" Grtb-wspace-id FORMAT ""X(16)"" SKIP"
    &center-criteria=NO
    &frame-no=1}
    
  FIND rtb.rtb_object NO-LOCK
    WHERE RECID(rtb.rtb_object) = ttXref.src-recid NO-ERROR.
   
  Mref-type = ENTRY(ttXref.ref-type,"{&XREF-TYPE-LIST}").
   
  DISPLAY 
    ttXref.obj-text       FORMAT "x(32)" COLUMN-LABEL "External Reference"
    rtb.rtb_object.OBJECT FORMAT "x(28)" COLUMN-LABEL "Referenced By"
    Mref-type                            COLUMN-LABEL "Ref Type"
    WITH STREAM-IO.
END.

/*
 Print all external include references.. 
*/
FOR EACH rtb.rtb_xref 
    WHERE rtb.rtb_xref.wspace-recid = RECID(rtb.rtb_wspace)
      AND rtb.rtb_xref.ref-type = 18
      NO-LOCK,
    rtb.rtb_object
    WHERE RECID(rtb.rtb_object) = rtb.rtb_xref.src-recid
      BY rtb.rtb_xref.obj-text 
      WITH FRAME ext-inc-obj-frame:

  {rtb/x/rtb_rpthdr.i
    &title="""External Objects Report"""
    &criteria="""Workspace:"" Grtb-wspace-id FORMAT ""X(16)"" SKIP(1)"
    &center-criteria=NO
    &frame-no=2}

  Mref-type = ENTRY(rtb.rtb_xref.ref-type,"{&XREF-TYPE-LIST}").
  
  DISPLAY 
    rtb.rtb_xref.obj-text
      FORMAT "x(32)"
      COLUMN-LABEL "External Reference"
    rtb.rtb_object.object
      FORMAT "x(28)"
      COLUMN-LABEL "Referenced By"
    Mref-type COLUMN-LABEL "Ref Type"
    WITH STREAM-IO.
END.

/* close print destination */
{rtb/g/rtbrpt2.i} 
