&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v7r10 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME DIALOG-1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS DIALOG-1 
/*------------------------------------------------------------------------
  File: rtb_0603.w
  Description: Xref Report - Call Diagram.
    This report produces a structure chart of the programs below a 
    given starting point. 
      Mobject     - name of program object to start with
      Mnode       - each element is a comma delimited list of objects
      Mnode-index - current elements entry being processed
      Mcur-node   - current node being processed
  Author: Erie D. Mead - copied from rtb_0603.p
  Created: 2/15/95
  To Do List:
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

{rtb/g/rtbglobl.i NEW}     /* Roundtable globals          */
{rtb/g/rtbrptv.i}          /* print destination variables */


&IF DEFINED(UIB_IS_RUNNING) &THEN
  DEFINE NEW SHARED BUFFER Brtb_object FOR rtb.rtb_object.
  FIND FIRST Brtb_object NO-LOCK NO-ERROR.
  Grtb-wspace-id = "40devel".
&ELSE
  DEFINE SHARED BUFFER Brtb_object FOR rtb.rtb_object.
&ENDIF


/* --- Define Locals --- */

DEFINE NEW SHARED VARIABLE Mobj-list AS CHARACTER NO-UNDO.
DEFINE NEW SHARED VARIABLE Mobj-ctrl AS CHARACTER NO-UNDO.
DEFINE NEW SHARED VARIABLE Mnum-levels AS INTEGER NO-UNDO.
DEFINE NEW SHARED VARIABLE Mtot-levels AS INTEGER NO-UNDO.
DEFINE NEW SHARED VARIABLE Mmax-levels AS INTEGER NO-UNDO.


DEFINE VARIABLE BT-Ok        AS HANDLE NO-UNDO.
DEFINE VARIABLE BT-Help      AS HANDLE NO-UNDO.
DEFINE VARIABLE BT-Cancel    AS HANDLE NO-UNDO.
DEFINE VARIABLE Mi           AS INTEGER NO-UNDO.
DEFINE VARIABLE Ml           AS INTEGER NO-UNDO.
DEFINE VARIABLE Mcur-level   AS INTEGER NO-UNDO.
DEFINE VARIABLE Mline        AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mspaces      AS CHARACTER NO-UNDO.
DEFINE VARIABLE Mfirst       AS LOGICAL NO-UNDO.
DEFINE VARIABLE Mdone-report AS LOGICAL INITIAL NO NO-UNDO.

/* End of defines */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE DIALOG-BOX
&Scoped-define DB-AWARE no

&Scoped-define LAYOUT-VARIABLE CURRENT-WINDOW-layout

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DIALOG-1

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS Mobject FI-Max-Levels Mwhite-space Mspacing 
&Scoped-Define DISPLAYED-OBJECTS Mobject FI-Max-Levels Mwhite-space Mspacing 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* Define a variable to store the name of the active layout.            */
DEFINE VAR CURRENT-WINDOW-layout AS CHAR INITIAL "Master Layout":U NO-UNDO.

/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE VARIABLE FI-Max-Levels AS INTEGER FORMAT ">9" INITIAL 0 
     LABEL "Max Levels" 
     VIEW-AS FILL-IN 
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 6 BY 1
     &ELSE SIZE 6 BY 1 &ENDIF NO-UNDO.

DEFINE VARIABLE Mobject AS CHARACTER FORMAT "x(100)" 
     LABEL "Lead in Program" 
     VIEW-AS FILL-IN 
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 30 BY 1
     &ELSE SIZE 30 BY 1 &ENDIF NO-UNDO.

DEFINE VARIABLE Mwhite-space AS INTEGER FORMAT "9":U INITIAL 2 
     LABEL "White Space" 
     VIEW-AS FILL-IN 
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 4 BY 1
     &ELSE SIZE 4 BY 1 &ENDIF NO-UNDO.

DEFINE VARIABLE Mspacing AS LOGICAL INITIAL no 
     LABEL "Extra Lines":L 
     VIEW-AS TOGGLE-BOX
     &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN SIZE 20 BY 1
     &ELSE SIZE 20 BY .81 &ENDIF NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DIALOG-1
     Mobject
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 2 COL 3
          &ELSE AT ROW 2 COL 7.4 &ENDIF HELP
          "Enter the name of the program from which to start." AUTO-RETURN 
     FI-Max-Levels
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 3 COL 18 COLON-ALIGNED
          &ELSE AT ROW 3.19 COL 22 COLON-ALIGNED &ENDIF HELP
          "Enter maximum number of levels to descend:  1 - 64." AUTO-RETURN 
     Mwhite-space
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 4 COL 18 COLON-ALIGNED
          &ELSE AT ROW 4.38 COL 22 COLON-ALIGNED &ENDIF HELP
          "Enter number of white spaces to indent each level"
     Mspacing
          &IF '{&WINDOW-SYSTEM}' = 'TTY':U &THEN AT ROW 6 COL 20
          &ELSE AT ROW 5.62 COL 24 &ENDIF HELP
          "Toggle on to double-space the report"
     SPACE(14.99) SKIP(3.18)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         FONT 4
         TITLE "Call Diagram Report":L.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: DIALOG-BOX
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX DIALOG-1
                                                                        */
ASSIGN 
       FRAME DIALOG-1:SCROLLABLE       = FALSE.

/* SETTINGS FOR FILL-IN Mobject IN FRAME DIALOG-1
   ALIGN-L                                                              */

/* _MULTI-LAYOUT-RUN-TIME-ADJUSTMENTS */

/* LAYOUT-NAME: "Standard Character"
   LAYOUT-TYPE: CHARACTER
   EXPRESSION:  SESSION:DISPLAY-TYPE = 'TTY':U 
   COMMENT:     This layout is the standard layout specification for
                 a customized Character based terminal.  It is usually
                 selected to modify a window that has a GUI based
                 master layout.
                                                                        */
IF SESSION:DISPLAY-TYPE = 'TTY':U  THEN 
  RUN CURRENT-WINDOW-layouts (INPUT 'Standard Character':U) NO-ERROR.

/* END-OF-LAYOUT-DEFINITIONS */

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME DIALOG-1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL DIALOG-1 DIALOG-1
ON GO OF FRAME DIALOG-1 /* Call Diagram Report */
DO:

    ASSIGN
      Mspacing     = Mspacing:SCREEN-VALUE = "YES"
      Mobject      = Mobject:SCREEN-VALUE
      Mwhite-space = INTEGER(Mwhite-space:SCREEN-VALUE)
      Mmax-levels  = INTEGER(FI-Max-Levels:SCREEN-VALUE).
 
/* --- validate Mobject here --- */
    FIND rtb.rtb_object WHERE rtb.rtb_object.wspace-id = Grtb-wspace-id
                          AND rtb.rtb_object.obj-type  = "PCODE"
                          AND rtb.rtb_object.object    = Mobject
                          NO-LOCK NO-ERROR.
      
    IF NOT AVAILABLE rtb.rtb_object THEN DO:
      MESSAGE 
        SUBSTITUTE("Cannot produce Call Diagram Report as Object '&1' does
 not exist.  Enter a new Object and try again.",Mobject)
        VIEW-AS ALERT-BOX ERROR
        TITLE "Roundtable Call Diagram Report".
      APPLY "ENTRY" TO Mobject IN FRAME {&FRAME-NAME}.
      RETURN NO-APPLY.
    END.  /* if not available rtb_object */
    
    /* --- validate Mmax-levels here --- */
    IF Mmax-Levels < 1 OR Mmax-Levels > 64 THEN DO:
      MESSAGE 
        "Cannot produce Call Diagram Report as Max Levels must be between 1
 and 64.  Enter a new Max Levels value and try again."
        VIEW-AS ALERT-BOX ERROR
        TITLE "Roundtable Call Diagram Report".
      APPLY "ENTRY" TO FI-Max-Levels IN FRAME {&FRAME-NAME}.
      RETURN NO-APPLY.
    END.  /* if (mmax-levels < 1 ... */

    IF SESSION:DISPLAY-TYPE = "TTY":U THEN
      HIDE FRAME DIALOG-1.

END.  /* on go of frame dialog-1 */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK DIALOG-1 


/* ***************************  Main Block  *************************** */

/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?
THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.

/* Add Trigger to equate WINDOW-CLOSE to END-ERROR                      */
ON WINDOW-CLOSE OF FRAME {&FRAME-NAME} APPLY "END-ERROR":U TO SELF.

IF AVAILABLE Brtb_object AND Brtb_object.obj-type = "PCODE" THEN
   ASSIGN Mobject = Brtb_object.object.           
   
/* --- Make OK,Create,Help buttons appear in frame --- */
IF SESSION:DISPLAY-TYPE = "TTY":U THEN
  DO:
    {rtb/g/rtb_okcan.i "{&FRAME-NAME}"}
  END.
ELSE
  DO:
    RUN make_def_ok_cancel IN Grtb-p-library (INPUT  FRAME {&FRAME-NAME}:HANDLE,
                                              OUTPUT BT-Ok,
                                              OUTPUT BT-Cancel,
                                              OUTPUT BT-Help).
    /* --- Help button trigger --- */
    ON CHOOSE OF BT-help OR HELP OF FRAME {&FRAME-NAME} DO:
      SYSTEM-HELP Grtb-help-file CONTEXT 881.
    END.
  END.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
RUN enable_UI.
MAIN-BLOCK:
DO WHILE TRUE ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
              ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
              
  WAIT-FOR GO OF FRAME {&FRAME-NAME}.

  RUN do_report.    
  
  IF Mdone-report THEN LEAVE MAIN-BLOCK.
  
END.
RUN disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI DIALOG-1  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME DIALOG-1.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE do_report DIALOG-1 
PROCEDURE do_report :
/* -----------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
-------------------------------------------------------------*/

  {rtb/g/rtbrpt1.i} /* set print destination */ 

  RPT-BLOCK:
  DO:                                           
  
    ASSIGN
      Mdone-report = YES.

    IF NOT AVAILABLE rtb.rtb_object THEN LEAVE RPT-BLOCK.    

    ASSIGN 
       Mnum-levels = 1
       Mobj-ctrl = "1,".
     
    /* Create Mobj-list and Mobj-ctrl lists */   
    RUN rtb/p/rtb0262.p (INPUT RECID(rtb.rtb_object)).

    ASSIGN
      Mspaces    = FILL(" ",MIN(Mwhite-space,INTEGER(64 - Mtot-levels /  Mtot-levels)))
      Mcur-level = 1
      Mfirst     = YES.

    DO Mi = 1 TO NUM-ENTRIES(Mobj-ctrl):

      ASSIGN Mobject = ENTRY(Mi,Mobj-list). 
      
      IF Mobject = "" THEN LEAVE.

      FIND FIRST rtb.rtb_object WHERE RECID(rtb.rtb_object) = ? NO-LOCK NO-ERROR.
      FIND FIRST rtb.rtb_ver    WHERE RECID(rtb.rtb_ver) = ? NO-LOCK NO-ERROR.
      FIND FIRST rtb.rtb_xref   WHERE RECID(rtb.rtb_xref) = ? NO-LOCK NO-ERROR.
 
      IF Mobject BEGINS "RV" OR Mobject BEGINS "IN":U THEN
         DO:  
         FIND rtb.rtb_xref 
              WHERE RECID(rtb.rtb_xref) = INTEGER(SUBSTRING(Mobject,4))
              NO-LOCK NO-ERROR.
         
                 IF Mobject BEGINS "RV":U THEN 
           Mobject = "RUN ":U.
         ELSE
           Mobject = "INVOKE ":U.
         
                 END.
      ELSE
      IF Mobject BEGINS "[" THEN
        FIND rtb.rtb_object WHERE rtb.rtb_object.wspace-id = Grtb-wspace-id 
                              AND rtb.rtb_object.obj-type  = "PCODE"
                              AND rtb.rtb_object.object    = 
                                 SUBSTRING(Mobject,INDEX(Mobject,"]") + 1)  
                              NO-LOCK NO-ERROR.

      ELSE IF Mobject BEGINS "*" THEN
        FIND rtb.rtb_object WHERE rtb.rtb_object.wspace-id = Grtb-wspace-id
                              AND rtb.rtb_object.obj-type  = "PCODE"
                              AND rtb.rtb_object.object    = 
                                 SUBSTRING(Mobject,2)
                              NO-LOCK NO-ERROR.

      ELSE
        FIND rtb.rtb_object WHERE rtb.rtb_object.wspace-id = Grtb-wspace-id
                              AND rtb.rtb_object.obj-type  = "PCODE"
                              AND rtb.rtb_object.object    = Mobject
                              NO-LOCK NO-ERROR.

      IF AVAILABLE rtb.rtb_object THEN
        FIND rtb.rtb_ver OF rtb.rtb_object NO-LOCK.
   
     /*
      If we have an actual object, add the description next to it.  If we an
      informal object that is either ran or invoked, print the approriate value
      from obj-text or ref-text.
     */
     Mobject =
       Mobject +
         IF AVAILABLE rtb.rtb_ver THEN
           " / " + rtb.rtb_ver.description
         ELSE
           (IF AVAILABLE rtb.rtb_xref AND Mobject BEGINS "RUN " THEN
              rtb.rtb_xref.ref-text
            ELSE IF AVAILABLE rtb.rtb_xref AND Mobject BEGINS "INVOKE " THEN  
              rtb.rtb_xref.obj-text
            ELSE
              "") +
             " / ** cannot follow to next level **".
 
      ASSIGN 
        Mcur-level = INTEGER(ENTRY(MI,Mobj-ctrl))
        Mline = STRING(Mi,">>>9") + " ".
      
      DO Ml = 2 TO Mcur-level:
        Mline = Mline + "|" + Mspaces.
      END.  /* do ml = 2 to mcur-level */

      {rtb/x/rtb_rpthdr.i 
        &title="""Call Diagram Report"""
        &criteria=""" Workspace:"" Grtb-wspace-id SKIP
                   ""Max Levels:""  Mmax-levels FORMAT "">9""
                   SKIP(1)"
        &center-criteria=NO}
 
      IF Mfirst THEN DO:
        PUT "[999] means see line 999,  * means Max levels hit but more exist" 
          SKIP(1).
        ASSIGN Mfirst = NO.
      END.  /* if mfirst */

      PUT Mline + Mobject FORMAT "x(80)" SKIP.
      IF Mspacing THEN PUT "    " + SUBSTRING(Mline,5) + "|"  FORMAT "x(80)"  SKIP.

    END.  /* do mi = 1 to NUM-ENTRIES(Mobj-ctrl) */
  END.  /* rtp-block */

  {rtb/g/rtbrpt2.i} /* close print destination */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI DIALOG-1  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY Mobject FI-Max-Levels Mwhite-space Mspacing 
      WITH FRAME DIALOG-1.
  ENABLE Mobject FI-Max-Levels Mwhite-space Mspacing 
      WITH FRAME DIALOG-1.
  {&OPEN-BROWSERS-IN-QUERY-DIALOG-1}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK  _PROCEDURE CURRENT-WINDOW-layouts _LAYOUT-CASES
PROCEDURE CURRENT-WINDOW-layouts:
  DEFINE INPUT PARAMETER layout AS CHARACTER                     NO-UNDO.
  DEFINE VARIABLE lbl-hndl AS WIDGET-HANDLE                      NO-UNDO.
  DEFINE VARIABLE widg-pos AS DECIMAL                            NO-UNDO.

  /* Copy the name of the active layout into a variable accessible to   */
  /* the rest of this file.                                             */
  CURRENT-WINDOW-layout = layout.

  CASE layout:
    WHEN "Master Layout" THEN DO:
      ASSIGN
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME DIALOG-1:HIDDEN                             = yes &ENDIF
         FRAME DIALOG-1:HEIGHT                             = 8.62
               + FRAME DIALOG-1:BORDER-TOP + FRAME DIALOG-1:BORDER-BOTTOM
         FRAME DIALOG-1:WIDTH                              = 58
               + FRAME DIALOG-1:BORDER-LEFT + FRAME DIALOG-1:BORDER-RIGHT.

      ASSIGN
         FI-Max-Levels:HIDDEN IN FRAME DIALOG-1            = yes
         widg-pos = FI-Max-Levels:COL IN FRAME DIALOG-1 
         FI-Max-Levels:COL IN FRAME DIALOG-1               = 24
         lbl-hndl = FI-Max-Levels:SIDE-LABEL-HANDLE IN FRAME DIALOG-1 
         lbl-hndl:COL = lbl-hndl:COL + FI-Max-Levels:COL IN FRAME DIALOG-1  - widg-pos
         widg-pos = FI-Max-Levels:ROW IN FRAME DIALOG-1 
         FI-Max-Levels:ROW IN FRAME DIALOG-1               = 3.19
         lbl-hndl = FI-Max-Levels:SIDE-LABEL-HANDLE IN FRAME DIALOG-1 
         lbl-hndl:ROW = lbl-hndl:ROW + FI-Max-Levels:ROW IN FRAME DIALOG-1  - widg-pos
         FI-Max-Levels:HIDDEN IN FRAME DIALOG-1            = no.

      ASSIGN
         Mobject:HIDDEN IN FRAME DIALOG-1                  = yes
         widg-pos = Mobject:COL IN FRAME DIALOG-1 
         Mobject:COL IN FRAME DIALOG-1                     = 24
         lbl-hndl = Mobject:SIDE-LABEL-HANDLE IN FRAME DIALOG-1 
         lbl-hndl:COL = lbl-hndl:COL + Mobject:COL IN FRAME DIALOG-1  - widg-pos
         Mobject:HIDDEN IN FRAME DIALOG-1                  = no.

      ASSIGN
         Mspacing:HIDDEN IN FRAME DIALOG-1                 = yes
         Mspacing:COL IN FRAME DIALOG-1                    = 24
         Mspacing:HEIGHT IN FRAME DIALOG-1                 = .81
         Mspacing:ROW IN FRAME DIALOG-1                    = 5.62
         Mspacing:HIDDEN IN FRAME DIALOG-1                 = no.

      ASSIGN
         Mwhite-space:HIDDEN IN FRAME DIALOG-1             = yes
         widg-pos = Mwhite-space:COL IN FRAME DIALOG-1 
         Mwhite-space:COL IN FRAME DIALOG-1                = 24
         lbl-hndl = Mwhite-space:SIDE-LABEL-HANDLE IN FRAME DIALOG-1 
         lbl-hndl:COL = lbl-hndl:COL + Mwhite-space:COL IN FRAME DIALOG-1  - widg-pos
         widg-pos = Mwhite-space:ROW IN FRAME DIALOG-1 
         Mwhite-space:ROW IN FRAME DIALOG-1                = 4.38
         lbl-hndl = Mwhite-space:SIDE-LABEL-HANDLE IN FRAME DIALOG-1 
         lbl-hndl:ROW = lbl-hndl:ROW + Mwhite-space:ROW IN FRAME DIALOG-1  - widg-pos
         Mwhite-space:HIDDEN IN FRAME DIALOG-1             = no.

      ASSIGN
         FRAME DIALOG-1:VIRTUAL-HEIGHT                     = 8.62                    WHEN FRAME DIALOG-1:SCROLLABLE
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME DIALOG-1:HIDDEN                             = no &ENDIF.

    END.  /* Master Layout Layout Case */

    WHEN "Standard Character":U THEN DO:
      ASSIGN
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME DIALOG-1:HIDDEN                             = yes &ENDIF
         FRAME DIALOG-1:HEIGHT                             = 8
               + FRAME DIALOG-1:BORDER-TOP + FRAME DIALOG-1:BORDER-BOTTOM
         FRAME DIALOG-1:WIDTH                              = 52
               + FRAME DIALOG-1:BORDER-LEFT + FRAME DIALOG-1:BORDER-RIGHT NO-ERROR.

      ASSIGN
         FI-Max-Levels:HIDDEN IN FRAME DIALOG-1            = yes
         widg-pos = FI-Max-Levels:COL IN FRAME DIALOG-1 
         FI-Max-Levels:COL IN FRAME DIALOG-1               = 20
         lbl-hndl = FI-Max-Levels:SIDE-LABEL-HANDLE IN FRAME DIALOG-1 
         lbl-hndl:COL = lbl-hndl:COL + FI-Max-Levels:COL IN FRAME DIALOG-1  - widg-pos
         widg-pos = FI-Max-Levels:ROW IN FRAME DIALOG-1 
         FI-Max-Levels:ROW IN FRAME DIALOG-1               = 3
         lbl-hndl = FI-Max-Levels:SIDE-LABEL-HANDLE IN FRAME DIALOG-1 
         lbl-hndl:ROW = lbl-hndl:ROW + FI-Max-Levels:ROW IN FRAME DIALOG-1  - widg-pos
         FI-Max-Levels:HIDDEN IN FRAME DIALOG-1            = no NO-ERROR.

      ASSIGN
         Mobject:HIDDEN IN FRAME DIALOG-1                  = yes
         widg-pos = Mobject:COL IN FRAME DIALOG-1 
         Mobject:COL IN FRAME DIALOG-1                     = 20
         lbl-hndl = Mobject:SIDE-LABEL-HANDLE IN FRAME DIALOG-1 
         lbl-hndl:COL = lbl-hndl:COL + Mobject:COL IN FRAME DIALOG-1  - widg-pos
         Mobject:HIDDEN IN FRAME DIALOG-1                  = no NO-ERROR.

      ASSIGN
         Mspacing:HIDDEN IN FRAME DIALOG-1                 = yes
         Mspacing:COL IN FRAME DIALOG-1                    = 20
         Mspacing:HEIGHT IN FRAME DIALOG-1                 = 1
         Mspacing:ROW IN FRAME DIALOG-1                    = 6
         Mspacing:HIDDEN IN FRAME DIALOG-1                 = no NO-ERROR.

      ASSIGN
         Mwhite-space:HIDDEN IN FRAME DIALOG-1             = yes
         widg-pos = Mwhite-space:COL IN FRAME DIALOG-1 
         Mwhite-space:COL IN FRAME DIALOG-1                = 20
         lbl-hndl = Mwhite-space:SIDE-LABEL-HANDLE IN FRAME DIALOG-1 
         lbl-hndl:COL = lbl-hndl:COL + Mwhite-space:COL IN FRAME DIALOG-1  - widg-pos
         widg-pos = Mwhite-space:ROW IN FRAME DIALOG-1 
         Mwhite-space:ROW IN FRAME DIALOG-1                = 4
         lbl-hndl = Mwhite-space:SIDE-LABEL-HANDLE IN FRAME DIALOG-1 
         lbl-hndl:ROW = lbl-hndl:ROW + Mwhite-space:ROW IN FRAME DIALOG-1  - widg-pos
         Mwhite-space:HIDDEN IN FRAME DIALOG-1             = no NO-ERROR.

      ASSIGN
         FRAME DIALOG-1:VIRTUAL-HEIGHT                     = 9.00                    WHEN FRAME DIALOG-1:SCROLLABLE
         &IF '{&WINDOW-SYSTEM}' NE 'TTY':U &THEN
         FRAME DIALOG-1:HIDDEN                             = no &ENDIF NO-ERROR.

    END.  /* Standard Character Layout Case */

  END CASE.
END PROCEDURE.  /* CURRENT-WINDOW-layouts */
&ANALYZE-RESUME

