/* schcomp.p -- compile the schema update procedures in rtb_inst so that
   they will work in any environment */
                            
/* --- Define Locals. --- */
DEFINE STREAM Supdlog.


/* --- Create a log of all errors that occurred during compile. --- */
OUTPUT TO rtb_ilog/schcomp.err NO-ECHO.

/* --- Create a lock file that the calling process will wait for. --- */
OUTPUT TO rtb_idat~/runlock.
OUTPUT CLOSE.    

/* --- Remove lock file created by calling process. --- */ 
OS-DELETE VALUE(SEARCH("rtb_idat~/strtlock")).


/* --- Create a log of all file actions perfromed during compile. --- */
OUTPUT STREAM Supdlog TO rtb_ilog/schcomp.log UNBUFFERED NO-ECHO.


/* --- Compile schema update programs. --- */
PUT STREAM Supdlog UNFORMATTED "Compiling schupd.p..." SKIP.
COMPILE rtb_inst~/schupd.p SAVE.

PUT STREAM Supdlog UNFORMATTED "Compiling schupd2.p..." SKIP.
COMPILE rtb_inst~/schupd2.p SAVE.

PUT STREAM Supdlog UNFORMATTED "Compiling schupdp2.p..." SKIP.
COMPILE rtb_inst~/schupdp2.p SAVE.

/* --- Close log files. --- */
OUTPUT STREAM Supdlog CLOSE.
OUTPUT CLOSE.


/* --- Remove runlock file. --- */
OS-DELETE VALUE(SEARCH("rtb_idat~/runlock")).
